#region Using directives

using System;
using System.Collections;
using System.Collections.Generic;

#endregion

namespace Framework.DxO.Converter.Impl
{
    /// <summary>
    /// IuWFNgT[]ȔzɕϊRo[^񋟂܂
    /// </summary>
    /// <author>Kazz.satou</author>
    /// <version> 1.0 11/24, 2006</version>
    ///
    public class ArrayConverter<T> : AbstractPropertyConverter
    {
        protected override bool DoConvert(object source, ref object dest, Type expectType)
        {
            if (dest == null)
            {
                //z^́AnullZbgĂ邱Ƃ̂ŃCX^X𐶐Ă
                dest = new T[0];
            }
            T[] result = (dest as T[]);
            Array.Clear(result, 0, result.Length);

            if (source is ICollection<T>)
            {
                //zReNew
                if ((source as ICollection<T>).Count > result.Length)
                {
                    result = new T[(source as ICollection<T>).Count];
                    dest = result;//z蒼̂œ]LKv
                }
                //WFlbNڃRs[ł
                (source as ICollection<T>).CopyTo(result, 0);
                return true;
            }
            //RNVΏ
            else if (source is ICollection)
            {
                //zReNew
                if ((source as ICollection).Count > result.Length)
                {
                    result = new T[(source as ICollection).Count];
                    dest = result;//z蒼̂œ]LKv
                }
                if (source.GetType().IsArray)
                {
                    if (source is T[])
                    {
                        //^v̔zȂΒڃRs[ł
                        (source as T[]).CopyTo(result, 0);
                        return true;
                    }
                    else
                    {
                        //vf̌^Ɍ݊邩ׂĂoNRs[
                        Type elementType = source.GetType().GetElementType();
                        if (typeof(T).IsAssignableFrom(elementType))
                        {
                            (source as Array).CopyTo(result, 0);
                            return true;
                        }
                    }
                }
                else
                {
                    //weWjAXȃRNV̏ꍇl1ACeɌ^`FbNKv
                    int i = 0;
                    foreach (object item in (source as ICollection))
                    {
                        //vf̌^Ɍ݊邩ׂăRs[
                        if (item.GetType().IsAssignableFrom(typeof(T)))
                        {
                            result.SetValue(item, i);
                            i++;
                        }
                        else
                        {
                            return false;
                        }
                    }
                    return true;
                }
            }
            return false;
        }
    }
}