#region Using directives

using System;
using System.Collections;
using System.Diagnostics;

#endregion

namespace Framework.DxO.Converter.Impl
{
    /// <summary>
    /// IuWFNgIDictionary֕ϊRo[^
    /// </summary>
    /// <author>Kazz.satou</author>
    /// <version> 1.0 11/24, 2006</version>
    ///
    public class DictionaryConverter : AbstractPropertyConverter 
    {
        protected override bool DoConvert(object source, ref object dest, Type expectType)
        {
            Debug.Assert(typeof(IDictionary).IsAssignableFrom(expectType)
                        , "expectTypeIDictionaryƌ݊ȂĂ͂ȂȂ");
            
            if (dest == null)
            {
                if (expectType.IsClass && !expectType.IsAbstract)
                {
                    dest = Activator.CreateInstance(expectType);
                }
                else
                {
                    throw new DxOException(
                        expectType.Name + "͋ۃNXł͂Ȃ̂Ŏ̉邱ƂłȂ");
                }
            }
            (dest as IDictionary).Clear();

            if (source is IDictionary)
            {
                foreach ( object key in (source as IDictionary).Keys)
                {
                    object value = (source as IDictionary)[key];
                    (dest as IDictionary).Add(key, value);
                }
                return true;
            }
            return false;
        }
    }

}