#region Using directives

using System;
using System.Collections;
using System.Collections.Generic;
using System.Diagnostics;
using System.Drawing;
using System.IO;

#endregion

namespace Framework.DxO.Converter.Impl
{
    /// <summary>
    /// IuWFNgImageɕϊRo[^B
    /// </summary>
    /// <author>Kazz.satou</author>
    /// <version> 1.0 11/24, 2006</version>
    ///
    public class ImageConverter : AbstractPropertyConverter
    {
        protected override bool DoConvert(object source, ref object dest, Type expectType)
        {
            Debug.Assert(typeof(Image).IsAssignableFrom(expectType)
                         , "expectTypeImageƌ݊ȂĂ͂ȂȂ");
            
            if (source is Image)
            {
                dest = (source as Image).Clone();
                return true;
            }
            else if (source is string)
            {
                string resource = source as string;
                if (File.Exists(resource))
                {
                    dest = Image.FromFile(resource);
                    return true;
                }
            }
            return false;
        }
    }
}