#region Using directives

using System;
using Framework.DxO.Converter;

#endregion

namespace Framework.DxO.Annotation
{
    /// <summary>
    /// DataExchange(DxO)ɑ΂āÃvpeBɑ΂ϊ@LqJX^񋟂܂
    /// </summary>
    /// <author>Kazz.satou</author>
    /// <version> 1.1 11/30, 2006</version>
    /// <seealso cref="Attribute"/>
    ///
    [AttributeUsage(AttributeTargets.Class, Inherited = true, AllowMultiple = true)]
    public class DxOMappingAttribute : Attribute
    {
        #region fields

        protected string propertyName;
        protected string targetPropertyName;
        protected Type propertyConverter;
        protected bool ignore = false;

        #endregion
        #region properties
        /// <summary>
        /// ϊJX^}CYvpeB擾Aݒ肵܂
        /// </summary>
        public string PropertyName
        {
            get { return this.propertyName; }
            set { this.propertyName = value; }
        }
        /// <summary>
        /// ϊƂȂvpeB擾Aݒ肵܂
        /// (ȗꍇAϊPropertyNameƓƂ݂Ȃ܂)
        /// </summary>
        public string TargetPropertyName
        {
            get { return this.targetPropertyName; }
            set { this.targetPropertyName = value; }
        }
        /// <summary>
        /// Ώۂ̃vpeBϊ邽߂̃Ro[^̌^擾Aݒ肷vpeBł
        /// (̌^̃ftHgRXgN^ŁARo[^̃CX^X𐶐邱Ƃ
        /// łȂĂ͂Ȃ܂)
        /// </summary>
        public Type PropertyConverter
        {
            get { return this.propertyConverter; }
            set { this.propertyConverter = value;}
        }
        /// <summary>
        /// vpeBƋɎw肷邱ƂŁA^ϊsȂƂw܂
        /// </summary>
        public bool Ignore
        {
            get { return this.ignore; }
            set { this.ignore = value;}
        }
        #endregion
    }
}
