#region Using directives

using System;
using System.Collections;
using System.Collections.Generic;
using System.Diagnostics;

#endregion

namespace Framework.DxO.Converter.Impl
{
    /// <summary>
    /// IuWFNgIListC^tF[XɕϊRo[^B
    /// </summary>
    /// <author>Kazz.satou</author>
    /// <version> 1.0 11/24, 2006</version>
    ///
    public class ListConverter : AbstractPropertyConverter
    {
        protected override bool DoConvert(object source, ref object dest, Type expectType)
        {
            Debug.Assert(typeof(IList).IsAssignableFrom(expectType)
                         , "expectTypeIListƌ݊ȂĂ͂ȂȂ");
            
            if (dest == null)
            {
                if (expectType.IsClass && !expectType.IsAbstract)
                {
                    dest = Activator.CreateInstance(expectType);
                }
                else
                {
                    throw new DxOException(
                        expectType.Name + "͋ۃNXł͂Ȃ̂Ŏ̉邱ƂłȂ");
                }
            }
            (dest as IList).Clear();
            if ( source is IEnumerable)
            {
                foreach (object item in (source as IEnumerable))
                {
                    (dest as IList).Add(item);
                }
                return true;
            }
            return false;
        }
    }
}