#region Using directives

using System;
using System.ComponentModel;
using System.Diagnostics;

#endregion

namespace Framework.DxO.Converter.Impl
{
    /// <summary>
    /// TypeConvertergāACӂ̌^ϊ邽߂̃Ro[^`܂
    /// </summary>
    /// <author>Kazz.satou</author>
    /// <version> 1.0 11/24, 2006</version>
    ///
    public class TypeConverterConverter : AbstractPropertyConverter
    {
        protected override bool DoConvert(object source, ref object dest, Type expectType)
        {
            TypeConverter converter = TypeDescriptor.GetConverter(expectType);

            if (converter != null)
            {
                if (converter.CanConvertFrom(source.GetType()))
                {
                    dest = converter.ConvertFrom(source);
                    return true;
                }

            }
            /*
            //^̏ꍇToString()gp
            if (expectType.Equals(typeof(string)))
            {
                dest = source.ToString();
                return true;
            }
            */
            return false;
        }
    }
}