#region Using directives

using System;
using System.ComponentModel;

using Framework.DxO.Converter;

#endregion

namespace Framework.DxO
{
    /// <summary>
    /// w(C)̃f𑊌ݕϊ邽߂̃C^tF[X`܂
    /// </summary>
    /// <author>Kazz.satou</author>
    /// <version> 1.0 11/24, 2006</version>
    ///
    public interface IDataExchange<S, D> 
    {
        /// <summary>
        /// ^S̃CX^X̓e^D̃CX^Xɕϊ܂
        /// </summary>
        /// <param name="source">ϊ̃CX^XZbg</param>
        /// <param name="dest">ϊ̃CX^XZbg</param>
        void Convert(S source, D dest);

        /// <summary>
        /// ^S̃CX^X̓eAVȌ^D̃CX^Xɕϊ܂
        /// (D̓NX^ŁAftHgRXgN^gpłKv܂)
        /// </summary>
        /// <param name="source">ϊZbg</param>
        /// <returns>D Vɐꂽ^D̃CX^X߂܂</returns>
        D Convert(S source);

        /// <summary>
        /// vpeB̃Ro[gOɔCxgł
        /// </summary>
        event ConvertEventHandler PrepareConvert;
        /// <summary>
        /// Ro[gۂɔCxgł
        /// </summary>
        event ConvertEventHandler ConvertCompleted;
        /// <summary>
        /// Ro[gsۂɔCxgł
        /// </summary>
        event ConvertEventHandler ConvertFail;
    }
}